## eckit 1.32.2

=== src/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

### sources

if( HAVE_EXPERIMENTAL )
  add_subdirectory( experimental )
endif()

add_subdirectory( eckit  )

add_subdirectory( tools )

add_subdirectory( sandbox )

=== src/tools/CMakeLists.txt ===
ecbuild_add_executable( TARGET      eckit_version
                        OUTPUT_NAME eckit-version
                        SOURCES     eckit-version.cc
                        LIBS        eckit_option eckit )

if( NOT eckit_HAVE_BUILD_TOOLS )
    return()
endif()

ecbuild_add_executable( TARGET      eckit_info
                        OUTPUT_NAME eckit-info
                        SOURCES     eckit-info.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      eckit_codec_list
                        OUTPUT_NAME eckit-codec-list
                        CONDITION   eckit_HAVE_ECKIT_CODEC
                        SOURCES     eckit-codec-list.cc
                        LIBS        eckit_codec eckit_option )

foreach( _name
        eckit-area-list
        eckit-grid
        eckit-grid-list
        eckit-grid-nearest
        eckit-grid-spec )
    string(REPLACE "-" "_" _target ${_name})
    ecbuild_add_executable( TARGET      ${_target}
                            OUTPUT_NAME ${_name}
                            SOURCES     ${_name}.cc
                            CONDITION   eckit_HAVE_ECKIT_GEO
                            LIBS        eckit_geo eckit_option )
endforeach()


### NOT TO INSTALL

ecbuild_add_executable( TARGET      dhcopy
                        OUTPUT_NAME eckit-dhcopy
                        NOINSTALL
                        SOURCES     dhcopy.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      syslog_server
                        OUTPUT_NAME eckit-syslog-server
                        NOINSTALL
                        SOURCES     syslog-server.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      syslog_client
                        OUTPUT_NAME eckit-syslog-client
                        NOINSTALL
                        SOURCES     syslog-client.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      eckit_rsync
                        OUTPUT_NAME eckit-rsync
                        CONDITION   eckit_HAVE_RSYNC
                        NOINSTALL
                        SOURCES     rsync.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      eckit_hash
                        OUTPUT_NAME eckit-hash
                        NOINSTALL
                        SOURCES     eckit-hash.cc
                        LIBS        eckit_option eckit )

=== tests/codec/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_test(
    TARGET  eckit_test_codec_encoding
    SOURCES test_codec_encoding.cc
    LIBS    eckit_codec
)

ecbuild_add_test(
    TARGET  eckit_test_codec_stream
    SOURCES test_codec_stream.cc
    LIBS    eckit_codec
)

ecbuild_add_executable(
    TARGET  eckit_test_codec_record
    SOURCES test_codec_record.cc
    LIBS    eckit_codec
    NOINSTALL
)

function( add_codec_test algorithm )
    string( TOUPPER ${algorithm} feature )
    if( eckit_HAVE_${feature} OR algorithm MATCHES "none" )
        ecbuild_add_test(
            TARGET      eckit_test_codec_record_COMPRESSION_${algorithm}
            COMMAND     eckit_test_codec_record
            ARGS        --suffix ".${algorithm}"
            ENVIRONMENT ECKIT_CODEC_COMPRESSION=${algorithm}
        )
    endif()
endfunction()

add_codec_test(none)
add_codec_test(aec)
add_codec_test(bzip2)
add_codec_test(lz4)
add_codec_test(snappy)

=== tests/filesystem/CMakeLists.txt ===
# aio system calls are know to fail on the Cray
# see https://sourceware.org/bugzilla/show_bug.cgi?id=11787

option( ENABLE_ECKIT-352 "Control if ECKIT-352 tests should be enabled" ON )

ecbuild_add_test( TARGET      eckit_test_filesystem_aiohandle
                  CONDITION   NOT DEFINED ENV{CRAYOS_VERSION} AND ${HAVE_AIO}
                  SOURCES     test_aiohandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_asynchandle
                  SOURCES     test_asynchandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_atomic_file_update
                  SOURCES     test_atomic_file_update.cc
                  LIBS        eckit )


ecbuild_add_test( TARGET      eckit_test_filesystem_localpathname
                  SOURCES     test_localpathname.cc
                  LIBS        eckit
                  CONDITION   ENABLE_ECKIT-352 )


ecbuild_add_test( TARGET      eckit_test_filesystem_restarthandle
                  SOURCES     test_restarthandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_pathexpander
                  SOURCES     test_pathexpander.cc
                  ENVIRONMENT "CURRENT_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}"
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_filemode
                  SOURCES     test_filemode.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_uri
                  SOURCES     test_uri.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pathname
                  SOURCES     test_pathname.cc
                  LIBS        eckit )

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tmp/foo)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/bar)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/baz)

=== tests/io/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
t.grib
)

if(HAVE_EXTRA_TESTS)
    ecbuild_get_test_multidata( TARGET get_eckit_io_test_data
                                NAMES ${test_data_files}
                                NOCHECK )
endif()

ecbuild_add_test( TARGET   eckit_test_filepool
                  SOURCES  test_filepool.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET  eckit_test_easycurl
                  SOURCES test_easycurl.cc
                  CONDITION HAVE_EXTRA_TESTS AND eckit_HAVE_CURL
                  LIBS    eckit )

file(
  COPY mock/MockREST.py mock/MockREST.launcher.sh
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
)

ecbuild_add_test( TARGET  eckit_test_urlhandle
                  SOURCES test_urlhandle.cc
                  CONDITION HAVE_EXTRA_TESTS AND eckit_HAVE_CURL
                  LIBS    eckit )

ecbuild_add_test( TARGET  eckit_test_circularbuffer
                  SOURCES test_circularbuffer.cc
                  LIBS    eckit )

ecbuild_add_test( TARGET      eckit_test_compress
                  SOURCES     test_compress.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_bitio
                  SOURCES     test_bitio.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_base64
                  SOURCES     test_base64.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_multihandle
                  SOURCES     test_multihandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_partfilehandle
                  SOURCES     test_partfilehandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledfile
                  SOURCES     test_pooledfile.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledhandle
                  SOURCES     test_pooledhandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_buffer
                  SOURCES     test_buffer.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_bufferlist
                  SOURCES     test_bufferlist.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_radoshandle
                  SOURCES     test_radoshandle.cc
                  CONDITION   HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_rados-performance
                  SOURCES     rados-performance.cc
                  CONDITION   HAVE_EXTRA_TESTS AND HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  TEST_DEPENDS get_eckit_io_test_data
                  LIBS        eckit )

=== tests/large_file/CMakeLists.txt ===
ecbuild_add_test( TARGET      eckit_test_large_file
                  SOURCES     test_large_file.cc
                  LIBS        eckit )

=== tests/memory/CMakeLists.txt ===
option( ENABLE_ECKIT-351 "Control if ECKIT-351 tests should be enabled" ON )

ecbuild_add_test( TARGET      eckit_test_memory_counted
                  SOURCES     test_counted.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_factory
                  SOURCES     test_factory.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_scoped_ptr
                  SOURCES     test_scoped_ptr.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_shared_ptr
                  SOURCES     test_shared_ptr.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_mmap
                  SOURCES     test_memory_mmap.cc
                  LIBS        eckit
                  CONDITION   ENABLE_ECKIT-351 )

=== tests/serialisation/CMakeLists.txt ===
ecbuild_add_test( TARGET   eckit_test_serialisation_file_stream
                  SOURCES  test_file_stream.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET   eckit_test_serialisation_streamable
                  SOURCES  test_streamable.cc
                  LIBS     eckit )

=== src/eckit/maths/CMakeLists.txt ===
list(APPEND eckit_maths_private_libs "${LAPACK_LIBRARIES}" "${BLAS_LIBRARIES}")
list(APPEND eckit_maths_sources
    Eigen.h
    FloatingPointExceptions.cc
    FloatingPointExceptions.h
    Lapack.cc
    Lapack.h
    Matrix.h
    Matrix3.h
    MatrixEigen.h
    MatrixLapack.h
)

if(CMAKE_CXX_COMPILER_ID MATCHES Intel)
    set_property(
      SOURCE    FloatingPointExceptions.cc
      APPEND
      PROPERTY  COMPILE_OPTIONS -fp-model precise)
    # See https://github.com/ecmwf/eckit/pull/206 
    # Without this, we get following error in a Intel Release build (-O3):
    #    eckit/maths/FloatingPointExceptions.cc:26:14: error: '#pragma STDC FENV_ACCESS ON' is illegal when precise is disabled
    #     | #pragma STDC FENV_ACCESS ON
    #     |              ^
endif()

if(eckit_HAVE_CONVEX_HULL)
    list(APPEND eckit_maths_sources ConvexHull.h ConvexHullN.h Qhull.cc Qhull.h)
    list(APPEND eckit_maths_private_libs Qhull::Qhull)
endif()

ecbuild_add_library(
    TARGET             eckit_maths
    TYPE               SHARED
    INSTALL_HEADERS    ALL
    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/maths
    SOURCES            ${eckit_maths_sources}
    PRIVATE_LIBS       ${eckit_maths_private_libs}
    PUBLIC_LIBS        eckit
)

if(eckit_HAVE_EIGEN)
    if(NOT EIGEN3_INCLUDE_DIRS AND TARGET Eigen3::Eigen)
        get_target_property(EIGEN3_INCLUDE_DIRS Eigen3::Eigen INTERFACE_INCLUDE_DIRECTORIES)
    endif()

    # Add include directories with "SYSTEM" to avoid warnings from within Eigen headers
    target_include_directories(eckit_maths SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIRS})
endif()

=== src/eckit/web/CMakeLists.txt ===
list( APPEND eckit_web_srcs
AgentResource.cc
AgentResource.h
CgiResource.cc
CgiResource.h
Configure.cc
FileResource.cc
FileResource.h
FtpRequest.h
Html.cc
Html.h
HtmlObject.cc
HtmlObject.h
HtmlResource.cc
HtmlResource.h
HttpResource.cc
HttpResource.h
HttpStream.cc
HttpStream.h
HttpServer.cc
HttpServer.h
HttpService.cc
HttpService.h
HttpUser.h
JSONResource.cc
JSONResource.h
JavaAgent.cc
JavaAgent.h
JavaResource.cc
JavaResource.h
JavaServer.cc
JavaServer.h
JavaService.cc
JavaService.h
JavaUser.cc
JavaUser.h
Url.cc
Url.h)


ecbuild_add_library( TARGET eckit_web TYPE SHARED
					 INSTALL_HEADERS LISTED
					 SOURCES
						${eckit_web_srcs}
					 PERSISTENT
						HtmlObject.h
					 HEADER_DESTINATION
						${INSTALL_INCLUDE_DIR}/eckit/web
					 PUBLIC_LIBS
						eckit )

=== debian/changelog ===
eckit (1.32.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Oct 2025 06:56:24 +0100

=== debian/control ===
Source: eckit
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  ecbuild (>= 3.6.1-1~),
  chrpath,
  flex,
  bison,
  libopenblas-dev [ !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  libjemalloc-dev,
  librados-dev,
  libradospp-dev,
  libproj-dev, 
  libbz2-dev,
  liblz4-dev,
  libshp-dev,
  libzip-dev,
  libeigen3-dev,
  libsnappy-dev,
  librsync-dev,
  libqhull-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev (>=  7.20),
  libncurses-dev
Standards-Version: 4.7.2
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  mpi-default-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libjemalloc-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
